package org.oorexx.ide.standalone.examples;

import com.intellij.lang.LighterASTNode;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.SyntaxTraverser;
import org.oorexx.ide.lang.psi.OoRexxDirective;
import org.oorexx.ide.lang.psi.OoRexxDirectiveMethod;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collections;


public class CheckForElement {

    public static void main(String[] args){
        try {

            File file = new File(CheckForElement.class.getResource("/examples/filesToParse/example1.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            System.out.println(String.join("", Collections.nCopies(0, " ")) + " " + root.getNode().getElementType().toString());

            printAST(0, root);

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }

    public static void printAST(int level, PsiElement root){
        for(PsiElement child: root.getChildren()){

            /*
             Check for method directive instance
                        DIRECTIVE                   parent
                                DIRECTIVE_START     child 0
                                DIRECTIVE_METHOD    child 1
                                ...
            */
            if(child instanceof OoRexxDirective) {
                PsiElement[] children = child.getChildren();
                if(children[1] instanceof OoRexxDirectiveMethod) {
                    System.out.println("--------------");
                    System.out.println("Method start");
                    System.out.println("--------------");
                }
            }

            System.out.println(String.join("", Collections.nCopies(level + 1, " ")) + " " + child.getNode().getElementType().toString());

            if(child.getChildren().length > 0)
                printAST(level + 1, child);

        }
    }
}
