package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.util.PsiTreeUtil;
import org.oorexx.ide.lang.psi.OoRexxKeywordInstruction;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collection;


public class CountKeywords {

    public static void main(String[] args){
        try {
            File file = new File(CheckForElement.class.getResource("/examples/filesToParse/example1.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            Collection<PsiElement> keywords = PsiTreeUtil.findChildrenOfType(root, OoRexxKeywordInstruction.class);

            System.out.println("There are " + keywords.size() + " keyword instructions.");

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }
}