package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.util.PsiTreeUtil;
import org.oorexx.ide.lang.psi.OoRexxKeywordInstruction;
import org.oorexx.ide.lang.psi.OoRexxStringLit;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collection;

public class CountKeywordsAndLiterals {

    public static void main(String[] args){
        try {
            File file = new File(CountKeywordsAndLiterals.class.getResource("/examples/filesToParse/example1.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            Collection<PsiElement> keywordsAndStringLiterals = PsiTreeUtil.findChildrenOfAnyType(root, OoRexxKeywordInstruction.class, OoRexxStringLit.class);

            System.out.println("The sum of keyword instructions and string literals is " + keywordsAndStringLiterals.size() + ".");

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }
}