package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.util.PsiTreeUtil;
import org.oorexx.ide.lang.psi.OoRexxExpr;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collection;


public class ExpressionPrinter {

    public static void main(String[] args){
        try {
            File file = new File(ExpressionPrinter.class.getResource("/examples/filesToParse/example2.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            Collection<PsiElement> exprs = PsiTreeUtil.findChildrenOfType(root, OoRexxExpr.class);

            System.out.println("The file contains following expressions: ");

            for(PsiElement expr: exprs){
                System.out.println(expr.getText());
            }

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }
}