package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiComment;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiErrorElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.util.PsiTreeUtil;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collection;

/**
 * Created by alex on 07.10.16.
 */
public class PrintComments {
    public static void main(String[] args){
        try {
            File file = new File(PrintComments.class.getResource("/examples/filesToParse/example4.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            Collection<PsiComment> comments = PsiTreeUtil.findChildrenOfType(root, PsiComment.class);

            for(PsiComment comment: comments){
                if(comment.getTokenType().toString().equals("DOC_COMMENT"))
                    System.out.println("DOC_COMMENT:\n" + comment.getText());

                if(comment.getTokenType().toString().equals("BLOCK_COMMENT"))
                    System.out.println("BLOCK_COMMENT:\n" + comment.getText());

                if(comment.getTokenType().toString().equals("EOL_COMMENT"))
                    System.out.println("EOL_COMMENT:\n" + comment.getText());

                System.out.println();
            }

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }
}
