package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiErrorElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.util.PsiTreeUtil;
import org.oorexx.ide.lang.psi.OoRexxKeywordInstruction;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collection;

/**
 * Created by alex on 07.10.16.
 */
public class PrintError {
    public static void main(String[] args){
        try {
            File file = new File(PrintError.class.getResource("/examples/filesToParse/example3.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            Collection<PsiErrorElement> errors = PsiTreeUtil.findChildrenOfType(root, PsiErrorElement.class);

            for(PsiErrorElement error: errors){
                System.out.println(error.getErrorDescription());
            }

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }
}
