package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collections;


public class SimpleASTPrinter {

    public static void main(String[] args){
        try {

            File file = new File(SimpleASTPrinter.class.getResource("/examples/filesToParse/example1.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            System.out.println(String.join("", Collections.nCopies(0, " ")) + " " + root.getNode().getElementType().toString());

            printAST(0, root);

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }

    public static void printAST(int level, PsiElement root){
        for(PsiElement child: root.getChildren()){

            System.out.println(String.join("", Collections.nCopies(level + 1, " ")) + " " + child.getNode().getElementType().toString());

            if(child.getChildren().length > 0)
                printAST(level + 1, child);

        }
    }
}
