package org.oorexx.ide.standalone.examples;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import org.oorexx.ide.standalone.OoRexxStandaloneParser;

import java.io.File;
import java.io.IOException;
import java.util.Collections;

/**
 * Created by alex on 07.10.16.
 */
public class SimpleASTPrinterWithRanges {
    public static void main(String[] args){
        try {

            File file = new File(SimpleASTPrinter.class.getResource("/examples/filesToParse/example1.rexx").getFile());

            PsiFile psiFile = OoRexxStandaloneParser.parse(file);

            PsiElement root = psiFile.getNode().getPsi();

            int startIndex = root.getTextRange().getStartOffset();
            int endIndex = startIndex + root.getTextLength();

            System.out.println(String.join("", Collections.nCopies(0, " ")) + " " + root.getNode().getElementType().toString() + "\t\t\tstart-index in text: " + startIndex + " \tend-index in text: " + endIndex );

            printAST(0, root);

        }catch (IOException ex){
            ex.printStackTrace();
        }
    }

    public static void printAST(int level, PsiElement root){
        for(PsiElement child: root.getChildren()){
            int startIndex = child.getTextRange().getStartOffset();
            int endIndex = startIndex + child.getTextLength();

            System.out.println(String.join("", Collections.nCopies(level + 1, " ")) + " " + child.getNode().getElementType().toString() + "\t\t\tstart-index in text: " + startIndex + " \tend-index in text: " + endIndex );

            if(child.getChildren().length > 0)
                printAST(level + 1, child);

        }
    }
}
